// DeadLockTest2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <process.h>
#include <windows.h>

CRITICAL_SECTION cs;
HANDLE           hMutex1;
HANDLE           hMutex2;

unsigned __stdcall  ThreadProc1(void *param)
{
  EnterCriticalSection(&cs);
  Sleep(2000);

  WaitForSingleObject(hMutex1,INFINITE);

  ReleaseMutex(hMutex1);
  LeaveCriticalSection(&cs);
  return 0;
}

unsigned __stdcall  ThreadProc2(void *param)
{
  WaitForSingleObject(hMutex1,INFINITE);
  WaitForSingleObject(hMutex1,INFINITE);
  Sleep(2000);

  WaitForSingleObject(hMutex2,INFINITE);

  ReleaseMutex(hMutex2);
  ReleaseMutex(hMutex1);
  return 0;
}

unsigned __stdcall  ThreadProc3(void *param)
{
  WaitForSingleObject(hMutex2,INFINITE);
  Sleep(2000);

  EnterCriticalSection(&cs);

  LeaveCriticalSection(&cs);
  ReleaseMutex(hMutex2);
  return 0;
}

int main(int argc, char* argv[])
{
   
   InitializeCriticalSection(&cs);
   hMutex1=CreateMutex(NULL,FALSE,NULL);
   hMutex2=CreateMutex(NULL,FALSE,NULL);

   HANDLE handle1 = (HANDLE) _beginthreadex(NULL, 0, ThreadProc1, NULL, 0, NULL);
   HANDLE handle2 = (HANDLE) _beginthreadex(NULL, 0, ThreadProc2, NULL, 0, NULL);
   HANDLE handle3 = (HANDLE) _beginthreadex(NULL, 0, ThreadProc3, NULL, 0, NULL);

   WaitForSingleObject(handle1,INFINITE);
   return 0;
}
